// Generated by rstantools.  Do not edit by hand.

/*
    trialr is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    trialr is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with trialr.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_ThallHierarchicalBinary_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 25> locations_array__ =
  {" (found before start of program)",
  " (in 'ThallHierarchicalBinary', line 20, column 2 to column 10)",
  " (in 'ThallHierarchicalBinary', line 21, column 2 to column 25)",
  " (in 'ThallHierarchicalBinary', line 22, column 2 to column 23)",
  " (in 'ThallHierarchicalBinary', line 25, column 2 to column 24)",
  " (in 'ThallHierarchicalBinary', line 26, column 2 to column 55)",
  " (in 'ThallHierarchicalBinary', line 27, column 2 to column 23)",
  " (in 'ThallHierarchicalBinary', line 30, column 4 to column 41)",
  " (in 'ThallHierarchicalBinary', line 29, column 2 to line 31, column 3)",
  " (in 'ThallHierarchicalBinary', line 28, column 2 to line 31, column 3)",
  " (in 'ThallHierarchicalBinary', line 35, column 2 to column 30)",
  " (in 'ThallHierarchicalBinary', line 36, column 2 to column 42)",
  " (in 'ThallHierarchicalBinary', line 37, column 2 to column 26)",
  " (in 'ThallHierarchicalBinary', line 38, column 2 to column 53)",
  " (in 'ThallHierarchicalBinary', line 9, column 2 to column 26)",
  " (in 'ThallHierarchicalBinary', line 10, column 31 to column 41)",
  " (in 'ThallHierarchicalBinary', line 10, column 2 to column 43)",
  " (in 'ThallHierarchicalBinary', line 11, column 27 to column 37)",
  " (in 'ThallHierarchicalBinary', line 11, column 2 to column 39)",
  " (in 'ThallHierarchicalBinary', line 13, column 2 to column 15)",
  " (in 'ThallHierarchicalBinary', line 14, column 2 to column 24)",
  " (in 'ThallHierarchicalBinary', line 16, column 2 to column 26)",
  " (in 'ThallHierarchicalBinary', line 17, column 2 to column 25)",
  " (in 'ThallHierarchicalBinary', line 22, column 11 to column 21)",
  " (in 'ThallHierarchicalBinary', line 26, column 43 to column 53)"};
#include <stan_meta_header.hpp>
class model_ThallHierarchicalBinary final : public model_base_crtp<model_ThallHierarchicalBinary> {
private:
  int num_groups;
  std::vector<int> group_responses;
  std::vector<int> group_sizes;
  double mu_mean;
  double mu_sd;
  double tau_alpha;
  double tau_beta;
public:
  ~model_ThallHierarchicalBinary() {}
  model_ThallHierarchicalBinary(stan::io::var_context& context__,
                                unsigned int random_seed__ = 0, std::ostream*
                                pstream__ = nullptr) : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_ThallHierarchicalBinary_namespace::model_ThallHierarchicalBinary";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 14;
      context__.validate_dims("data initialization", "num_groups", "int",
        std::vector<size_t>{});
      num_groups = std::numeric_limits<int>::min();
      current_statement__ = 14;
      num_groups = context__.vals_i("num_groups")[(1 - 1)];
      current_statement__ = 14;
      stan::math::check_greater_or_equal(function__, "num_groups",
        num_groups, 1);
      current_statement__ = 15;
      stan::math::validate_non_negative_index("group_responses",
        "num_groups", num_groups);
      current_statement__ = 16;
      context__.validate_dims("data initialization", "group_responses",
        "int", std::vector<size_t>{static_cast<size_t>(num_groups)});
      group_responses = std::vector<int>(num_groups,
                          std::numeric_limits<int>::min());
      current_statement__ = 16;
      group_responses = context__.vals_i("group_responses");
      current_statement__ = 16;
      stan::math::check_greater_or_equal(function__, "group_responses",
        group_responses, 0);
      current_statement__ = 17;
      stan::math::validate_non_negative_index("group_sizes", "num_groups",
        num_groups);
      current_statement__ = 18;
      context__.validate_dims("data initialization", "group_sizes", "int",
        std::vector<size_t>{static_cast<size_t>(num_groups)});
      group_sizes = std::vector<int>(num_groups,
                      std::numeric_limits<int>::min());
      current_statement__ = 18;
      group_sizes = context__.vals_i("group_sizes");
      current_statement__ = 18;
      stan::math::check_greater_or_equal(function__, "group_sizes",
        group_sizes, 0);
      current_statement__ = 19;
      context__.validate_dims("data initialization", "mu_mean", "double",
        std::vector<size_t>{});
      mu_mean = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 19;
      mu_mean = context__.vals_r("mu_mean")[(1 - 1)];
      current_statement__ = 20;
      context__.validate_dims("data initialization", "mu_sd", "double",
        std::vector<size_t>{});
      mu_sd = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 20;
      mu_sd = context__.vals_r("mu_sd")[(1 - 1)];
      current_statement__ = 20;
      stan::math::check_greater_or_equal(function__, "mu_sd", mu_sd, 0.0);
      current_statement__ = 21;
      context__.validate_dims("data initialization", "tau_alpha", "double",
        std::vector<size_t>{});
      tau_alpha = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 21;
      tau_alpha = context__.vals_r("tau_alpha")[(1 - 1)];
      current_statement__ = 21;
      stan::math::check_greater_or_equal(function__, "tau_alpha", tau_alpha,
        0);
      current_statement__ = 22;
      context__.validate_dims("data initialization", "tau_beta", "double",
        std::vector<size_t>{});
      tau_beta = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 22;
      tau_beta = context__.vals_r("tau_beta")[(1 - 1)];
      current_statement__ = 22;
      stan::math::check_greater_or_equal(function__, "tau_beta", tau_beta, 0);
      current_statement__ = 23;
      stan::math::validate_non_negative_index("rho", "num_groups", num_groups);
      current_statement__ = 24;
      stan::math::validate_non_negative_index("prob_response", "num_groups",
        num_groups);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = 1 + 1 + num_groups;
  }
  inline std::string model_name() const final {
    return "model_ThallHierarchicalBinary";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ =
      "model_ThallHierarchicalBinary_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      local_scalar_t__ mu = DUMMY_VAR__;
      current_statement__ = 1;
      mu = in__.template read<local_scalar_t__>();
      local_scalar_t__ sigma2 = DUMMY_VAR__;
      current_statement__ = 2;
      sigma2 = in__.template read_constrain_lb<local_scalar_t__,
                 jacobian__>(0.0, lp__);
      std::vector<local_scalar_t__> rho =
        std::vector<local_scalar_t__>(num_groups, DUMMY_VAR__);
      current_statement__ = 3;
      rho = in__.template read<std::vector<local_scalar_t__>>(num_groups);
      local_scalar_t__ sigma = DUMMY_VAR__;
      std::vector<local_scalar_t__> prob_response =
        std::vector<local_scalar_t__>(num_groups, DUMMY_VAR__);
      current_statement__ = 6;
      sigma = stan::math::sqrt(sigma2);
      current_statement__ = 9;
      for (int i = 1; i <= num_groups; ++i) {
        current_statement__ = 7;
        stan::model::assign(prob_response,
          stan::math::inv_logit(
            stan::model::rvalue(rho, "rho", stan::model::index_uni(i))),
          "assigning variable prob_response", stan::model::index_uni(i));
      }
      current_statement__ = 4;
      stan::math::check_greater_or_equal(function__, "sigma", sigma, 0.0);
      current_statement__ = 5;
      stan::math::check_greater_or_equal(function__, "prob_response",
        prob_response, 0.0);
      current_statement__ = 5;
      stan::math::check_less_or_equal(function__, "prob_response",
        prob_response, 1.0);
      {
        current_statement__ = 10;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(mu, mu_mean, mu_sd));
        current_statement__ = 11;
        lp_accum__.add(stan::math::inv_gamma_lpdf<propto__>(sigma2,
                         tau_alpha, tau_beta));
        current_statement__ = 12;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(rho, mu, sigma));
        current_statement__ = 13;
        lp_accum__.add(stan::math::binomial_logit_lpmf<propto__>(
                         group_responses, group_sizes, rho));
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_ThallHierarchicalBinary_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      double mu = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 1;
      mu = in__.template read<local_scalar_t__>();
      double sigma2 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 2;
      sigma2 = in__.template read_constrain_lb<local_scalar_t__,
                 jacobian__>(0.0, lp__);
      std::vector<double> rho =
        std::vector<double>(num_groups,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 3;
      rho = in__.template read<std::vector<local_scalar_t__>>(num_groups);
      double sigma = std::numeric_limits<double>::quiet_NaN();
      std::vector<double> prob_response =
        std::vector<double>(num_groups,
          std::numeric_limits<double>::quiet_NaN());
      out__.write(mu);
      out__.write(sigma2);
      out__.write(rho);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 6;
      sigma = stan::math::sqrt(sigma2);
      current_statement__ = 9;
      for (int i = 1; i <= num_groups; ++i) {
        current_statement__ = 7;
        stan::model::assign(prob_response,
          stan::math::inv_logit(
            stan::model::rvalue(rho, "rho", stan::model::index_uni(i))),
          "assigning variable prob_response", stan::model::index_uni(i));
      }
      current_statement__ = 4;
      stan::math::check_greater_or_equal(function__, "sigma", sigma, 0.0);
      current_statement__ = 5;
      stan::math::check_greater_or_equal(function__, "prob_response",
        prob_response, 0.0);
      current_statement__ = 5;
      stan::math::check_less_or_equal(function__, "prob_response",
        prob_response, 1.0);
      if (emit_transformed_parameters__) {
        out__.write(sigma);
        out__.write(prob_response);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ mu = DUMMY_VAR__;
      current_statement__ = 1;
      mu = in__.read<local_scalar_t__>();
      out__.write(mu);
      local_scalar_t__ sigma2 = DUMMY_VAR__;
      current_statement__ = 2;
      sigma2 = in__.read<local_scalar_t__>();
      out__.write_free_lb(0.0, sigma2);
      std::vector<local_scalar_t__> rho =
        std::vector<local_scalar_t__>(num_groups, DUMMY_VAR__);
      current_statement__ = 3;
      stan::model::assign(rho,
        in__.read<std::vector<local_scalar_t__>>(num_groups),
        "assigning variable rho");
      out__.write(rho);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "mu", "double",
        std::vector<size_t>{});
      current_statement__ = 2;
      context__.validate_dims("parameter initialization", "sigma2", "double",
        std::vector<size_t>{});
      current_statement__ = 3;
      context__.validate_dims("parameter initialization", "rho", "double",
        std::vector<size_t>{static_cast<size_t>(num_groups)});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ mu = DUMMY_VAR__;
      current_statement__ = 1;
      mu = context__.vals_r("mu")[(1 - 1)];
      out__.write(mu);
      local_scalar_t__ sigma2 = DUMMY_VAR__;
      current_statement__ = 2;
      sigma2 = context__.vals_r("sigma2")[(1 - 1)];
      out__.write_free_lb(0.0, sigma2);
      std::vector<local_scalar_t__> rho =
        std::vector<local_scalar_t__>(num_groups, DUMMY_VAR__);
      current_statement__ = 3;
      rho = context__.vals_r("rho");
      out__.write(rho);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"mu", "sigma2", "rho"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"sigma", "prob_response"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{},
                std::vector<size_t>{},
                std::vector<size_t>{static_cast<size_t>(num_groups)}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{},
             std::vector<size_t>{static_cast<size_t>(num_groups)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "mu");
    param_names__.emplace_back(std::string() + "sigma2");
    for (int sym1__ = 1; sym1__ <= num_groups; ++sym1__) {
      param_names__.emplace_back(std::string() + "rho" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      param_names__.emplace_back(std::string() + "sigma");
      for (int sym1__ = 1; sym1__ <= num_groups; ++sym1__) {
        param_names__.emplace_back(std::string() + "prob_response" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "mu");
    param_names__.emplace_back(std::string() + "sigma2");
    for (int sym1__ = 1; sym1__ <= num_groups; ++sym1__) {
      param_names__.emplace_back(std::string() + "rho" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      param_names__.emplace_back(std::string() + "sigma");
      for (int sym1__ = 1; sym1__ <= num_groups; ++sym1__) {
        param_names__.emplace_back(std::string() + "prob_response" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {}
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"mu\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma2\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"rho\",\"type\":{\"name\":\"array\",\"length\":" + std::to_string(num_groups) + ",\"element_type\":{\"name\":\"real\"}},\"block\":\"parameters\"},{\"name\":\"sigma\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"},{\"name\":\"prob_response\",\"type\":{\"name\":\"array\",\"length\":" + std::to_string(num_groups) + ",\"element_type\":{\"name\":\"real\"}},\"block\":\"transformed_parameters\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"mu\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma2\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"rho\",\"type\":{\"name\":\"array\",\"length\":" + std::to_string(num_groups) + ",\"element_type\":{\"name\":\"real\"}},\"block\":\"parameters\"},{\"name\":\"sigma\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"},{\"name\":\"prob_response\",\"type\":{\"name\":\"array\",\"length\":" + std::to_string(num_groups) + ",\"element_type\":{\"name\":\"real\"}},\"block\":\"transformed_parameters\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((1 + 1) + num_groups);
    const size_t num_transformed = emit_transformed_parameters * ((1 +
      num_groups));
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((1 + 1) + num_groups);
    const size_t num_transformed = emit_transformed_parameters * ((1 +
      num_groups));
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_ThallHierarchicalBinary_namespace::model_ThallHierarchicalBinary;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_ThallHierarchicalBinary_namespace::profiles__;
}
#endif
#endif
